/*-
 * Copyright (c) 2011 aian
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
#ifndef QIE__GRAY_IMAGE_H
#define QIE__GRAY_IMAGE_H

#include <vector>

namespace qie {

class gray_image {
public:
  gray_image();
  gray_image(const gray_image& other);
  virtual ~gray_image();
public:
  gray_image& operator=(const gray_image& rhs);
public:
  unsigned char get_pixel(int x, int y) const;
  void set_pixel(int x, int y, unsigned char value);
  void fill(unsigned char value);
public:
  void alloc(int width, int height, unsigned char value = 0);
  void clear();
  void swap(gray_image& other) throw ();
public:
  int width() const throw ();
  int height() const throw ();
  bool is_alloced() const throw ();
private:
  bool is_valid_coord(int x, int y) const throw ();
private:
  int width_;
  int height_;
  std::vector<unsigned char> pixels_;
};

}

#endif  // QIE__GRAY_IMAGE_H
