/*-
 * Copyright (c) 2011 aian
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
#ifndef QIE__PGM_WRITER_H
#define QIE__PGM_WRITER_H

#include <string>
#include <libqie/pnm_common.h>
#include <libqie/pnm_header.h>

namespace qie {

class gray_image;

class pgm_writer {
public:
  pgm_writer();
  virtual ~pgm_writer();
private:  // no implement
  pgm_writer(const pgm_writer& other);
  pgm_writer& operator=(const pgm_writer& rhs);
public:
  void set_header(const pnm_header& header);
  void write(const std::string& fname, const gray_image& image) const;
private:
  void write_header(std::ofstream& ofs, const gray_image& image) const;
  void write_ascii_pixels(std::ofstream& ofs, const gray_image& image) const;
  void write_binary_pixels(std::ofstream& ofs, const gray_image& image) const;
private:
  bool is_valid_header(const pnm_header& header) const throw ();
private:
  pnm_header header_;
};

}

#endif  // QIE__PGM_WRITER_H
