/*-
 * Copyright (c) 2011 aian
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
#ifndef QIE__PNM_HEADER_H
#define QIE__PNM_HEADER_H

#include <string>
#include <libqie/pnm_common.h>
#include <libqie/pnm_header.h>

namespace qie {

class pnm_header {
public:
  pnm_header();
  pnm_header(const pnm_header& other);
  virtual ~pnm_header();
public:
  pnm_header& operator=(const pnm_header& rhs);
public:
  void set_width(int width) throw ();
  void set_height(int height) throw ();
  void set_depth(int depth) throw ();
  void set_format(const pnm_format_t& format) throw ();
  void set_format(const std::string& format) throw ();
public:
  pnm_format_t format() const throw ();
  std::string format_string() const throw ();
  int width() const throw ();
  int height() const throw ();
  int depth() const throw ();
public:
  void swap(pnm_header& other) throw ();
private:
  pnm_format_t format_;
  int width_;
  int height_;
  int depth_;
};

}

#endif  // QIE__PNM_HEADER_H
